Option Explicit
Dim tsIn, tsOut
Dim A, B, C, D, E, F, G, InpStr, GameOver, QuitGame

Function NotInStr(ByVal Start, StrVal)
  Do
    If Start > Len(StrVal) Then
      Exit Do
    ElseIf Mid(StrVal, Start, 1) <> "#" Then
      Exit Do
    Else
      Start = Start + 1
    End If
  Loop
  NotInStr = Start
End Function

Function FmtInt(ByVal IntVal, ByVal Width)
  FmtInt = Right(Space(Width - 1) & CStr(IntVal), Width)
End Function

Function FmtInts(IntVals, ByVal FmtStr)
  Dim I, Start, Width, Arr

  For I = 0 To UBound(IntVals)
    Start = InStr(1, FmtStr, "#")
    Width = NotInStr(Start + 1, FmtStr) - Start
    Arr = Split(FmtStr, String(Width, "#"), 2)
    FmtStr = Arr(0) & FmtInt(IntVals(I), Width) & Arr(1)
  Next
  FmtInts = FmtStr
End Function

Function ParseGoodInp(ByVal InpStr, A, B, C)
  Dim Arr

  Arr = Split(InpStr, ",")
  If UBound(Arr) <> 2 Then Exit Function 'Returning False.
  A = CInt(Arr(0)) : B = CInt(Arr(1)) : C = CInt(Arr(2))
  ParseGoodInp = True
End Function

Sub PlayAgain()
  GameOver = True
  tsOut.WriteLine : tsOut.WriteChars "Want to play again? "
  InpStr = tsIn.ReadLine() : QuitGame = UCase(Left(InpStr, 1)) <> "Y"
End Sub

Sub KilledPlayAgain()
  .WriteLine "You were killed and " & CStr(200 - G) & " rounds later the building"
  .WriteLine "blew up!!"
  PlayAgain
End Sub

Set tsIn = WScript.StdIn
On Error Resume Next
A = tsIn.Column 'Test for valid TextStream.
If Err.Number <> 0 Then
  On Error GoTo 0
  WScript.Echo "Run with CScript instead of WScript"
  WScript.Quit
End If
On Error GoTo 0
Set tsOut = WScript.StdOut
Randomize

With tsOut
  .WriteLine "        Defuse"
  .WriteLine "  Creative Computing"
  .WriteLine "Morristown, New Jersey"
  .WriteBlankLines(3)
  .WriteLine "You are in a government experimental building with 1,000,000"
  .WriteLine "rooms in it. The building is 100 rooms long (0 - 99),"
  .WriteLine "100 rooms wide (0 - 99), and 100 rooms high (0 - 99)"
  .WriteLine : .WriteLine "In it a bomb is hidden. The bomb sends out signals that"
  .WriteLine "gets stronger as you get closer. You have 10 rounds"
  .WriteLine "to deactivate it."
  .WriteLine
  .WriteLine "Enter coords to move to as 3 comma-separated values!"
  .WriteLine
  Do
    A = Int(Rnd * 100) : B = Int(Rnd * 100) : C = Int(Rnd * 100)
    D = 0 : E = 0 : F = 0 : G = 0
    .WriteLine "Signal    L  W  H    Round    New Coordinates (L,W,H)"
    Do
      .WriteLine FormatNumber(10000 - Abs((A / 100 + B + C * 100) - (D / 100 + E + F * 100)), 2, 0, 0, 0)
      Do
        .WriteChars FmtInts(Array(D, E, F, G), _
                            "         ## ## ##     ##    ? ")
        InpStr = tsIn.ReadLine()
      Loop Until ParseGoodInp(InpStr, D, E, F)
      .WriteLine
      G = G + 1
      If A <> D Or B <> E Or C <> F Then
        If G = 10 Then
          .WriteLine "BOOOOOM!!!" : .WriteLine "You blew it. The building blew up."
          .WriteLine "The bomb was located at the coordinates (L,W,H): " _
                   & CStr(A) & ", " & CStr(B) & ", " & CStr(C)
          PlayAgain
        ElseIf 0 > D Or D > 99 Or 0 > E Or E > 99 Then
          .Write "You walked out of a window on the " & CStr(F)
          If F < 4 Then .WriteLine "st floor!!!" Else .WriteLine "th floor!!!"
          KilledPlayAgain
        ElseIf F < 0 Then
          .WriteLine "You are now " & CStr(-1 * (F * 9)) & " feet underground!!!"
          KilledPlayAgain
        ElseIf F > 99 Then
          .WriteLine "You are now " & CStr(F * 9) & " feet in the air!!!"
          KilledPlayAgain
        End If
      ElseIf A = D And B = E And C = F Then
        .WriteLine "Bomb deactivated at " & CStr(G) & " seconds!!!"
        PlayAgain
      End If
    Loop Until GameOver
  Loop Until QuitGame
End With
