VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WScriptSim"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
'WScriptSim
'==========
'
'Global Object class, an instance of which is added to the
'Script Control as global object "WScript".  This is how our
'scripts interact with the host.
'
'In a real application that is hosting script you'd have more
'useful properties and methods for automating the application.
'
'Here is where you would implement a WScript object emulator.
'

Private Declare Sub SleepAPI Lib "kernel32" Alias "Sleep" (ByVal dwMilliseconds As Long)

Private WshStdIn As New StdInSim
Private WshStdOut As StdOutSim

Public Property Get Arguments() As Collection
    Set Arguments = New Collection 'Empty.  You could get fancier with this.
End Property

Public Property Get BuildVersion() As String
    BuildVersion = CStr(App.Revision) 'Hardcode a value to simulate a WSH build.
End Property

Public Property Get FullName() As String
    FullName = Path & "\" & Name
End Property

Public Property Get Name() As String
    Name = App.EXEName & ".exe"
End Property

Public Property Get Path() As String
    Path = App.Path
End Property

Public Property Get ScriptFullName() As String
    If gstrScriptFullName = gNEW_FLAG Then
        Err.Raise &H80047700, "WScriptSim", "ScriptFullName invalid until script is saved"
    Else
        ScriptFullName = gstrScriptFullName
    End If
End Property

Public Property Get ScriptName() As String
    If gstrScriptName = gNEW_FLAG Then
        Err.Raise &H80047702, "WScriptSim", "ScriptName invalid until script is saved"
    Else
        ScriptName = gstrScriptName
    End If
End Property

Public Property Get StdIn() As StdInSim
    Set StdIn = WshStdIn
End Property

Public Property Get StdErr() As StdOutSim
    Set StdErr = WshStdOut
End Property

Public Property Get StdOut() As StdOutSim
    Set StdOut = WshStdOut
End Property

Public Property Get Version() As String
    Version = gstrWSHVersion
End Property

Public Function CreateObject(ByVal ProgId As String, Optional ByVal Prefix As String) As Object
    Set CreateObject = VBA.CreateObject(ProgId)
End Function

Public Sub Echo(ParamArray Text())
    WshStdOut.WriteLine Join$(Text, vbNewLine)
End Sub

Public Sub Quit(Optional ByVal Status As Long)
    Err.Raise 51 'Internal error, catch this in Script Control Error event!
End Sub

Public Sub Sleep(ByVal Milliseconds As Long)
    DoEvents
    If Milliseconds > 0 Then SleepAPI Milliseconds
    If gblnAbort Then
        gblnAbort = False
        Err.Raise 51 'Abort script.
    End If
End Sub

Private Sub Class_Initialize()
    Set WshStdOut = New StdOutSim
    Set WshStdIn = New StdInSim
    Set WshStdIn.StdOut = WshStdOut 'Used to echo inputs.
End Sub
